WTN = LibStub("AceAddon-3.0"):NewAddon("WhereToNow", "AceConsole-3.0", "AceEvent-3.0")

-- Handle skill up and update the display
WTN:RegisterEvent("CHAT_MSG_SKILL", 
	function() 
		WTN:CheckProfs()
		fontstring2:SetText(skillLevel.."/"..maxSkillLevel)
		WTN:Location()	
		WTN:SkillNowCheck()			
end)
	
function WTN:OnInitialize()	 
	 Race = UnitRace("player")	 
end

function WTN:OnEnable()
 	WTN:Create()  	
  	print("WhereToNow loaded succesfully.")  
  	WTN:CheckTrack()	
end

WTN:RegisterEvent("MINIMAP_UPDATE_TRACKING",
	function()
		WTN:CheckTrack()		
end)

function WTN:CheckTrack()
	i = 0  	
  	while i <= GetNumTrackingTypes() do
  	  	Tname, Ttexture, Tactive, Tcategory = GetTrackingInfo(i)
  		if Tname == "Find Minerals" then
  			if Tactive == nil then
  				frame:Hide()
  			end
  			if Tactive == 1 then
  				frame:Show()
  			end		
  		end	
  		i = i + 1
  	end	
end	

WTN:RegisterEvent("PLAYER_LOGOUT",
	function()
		point, relativeTo, relativePoint, xOfs, yOfs = frame:GetPoint()
		point = point
		relativeTo = relativeTo
		relativePoint = relativePoint
		xOffset = xOffSet
		yOffset = yOffset
end)	

function WTN:OnDisable()
   --
end

-- Create the container on login
function WTN:Create()
   	frame = CreateFrame("Frame", "WhereToNow", UIParent)
   	frame:SetWidth(125)
   	frame:SetHeight(80)
   	frame:SetFrameStrata("Background")
   	if point ~= nil then
		frame:SetPoint(point, xOffset, yOffset)
   	end
	if point == nil then
		frame:SetPoint("CENTER", 0, 0)
	end
	
	frame:EnableMouse(true)
   	frame:SetMovable(true)
   	frame:RegisterForDrag("LeftButton")

   	t = frame:CreateTexture(nil,"BACKGROUND")
   	t:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Background.blp")
   	t:SetAllPoints(frame)
   	frame.texture = t
 
    frame:SetScript("OnDragStart", 
    	function(frame, button)
			frame:StartMoving()
	end) 

	frame:SetScript("OnDragStop", 
		function(frame, button)
			frame:StopMovingOrSizing()
			-- get container position and save it here NYI
	end) 
	fontstring = frame:CreateFontString("name", "frame", "ActionBarButtonTemplate")
	fontstring2 = frame:CreateFontString("name", "frame", "ActionBarButtonTemplate")
	
	WTN:CheckProfs()
end

function WTN:CheckProfs()
	prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions("player"); 	
 	-- Get Trade skill One
 	
 	if prof1 ~= nil then 
 		WTN:SkillTrackCreate(prof1)
 	end
 	if prof2 ~= nil then
 		WTN:SkillTrackCreate(prof2)
 	end 	
end

function WTN:SkillTrackCreate(prof)
	name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier = GetProfessionInfo(prof)
		if name == "Mining" then
 			WTN:CreateProfIcon()
			WTN:Location()			
 		end	
 end

-- Create Profession icon. Separate from the create logic to make expanding to other 
-- professions easier to handle.
function WTN:CreateProfIcon()
	fontstring:SetFont("Fonts\\ARIALN.ttf", 12, "MONOCHROME") 	
	fontstring:SetPoint("CENTER", 0, 25)
	b = CreateFrame("Button", "btn1", frame)
	b:SetWidth(16)
	b:SetHeight(16)
	b:SetPoint("CENTER", -30, 25)
	te = b:CreateTexture(nil,"BACKGROUND")
	te:SetTexture(icon)
	te:SetAllPoints(b)
	b.texture = te
	fontstring:SetText(name)

	
	fontstring2:SetFont("Fonts\\ARIALN.ttf", 12, "MONOCHROME") 	
	fontstring2:SetPoint("CENTER", 0, 10)

	fontstring2:SetText(skillLevel.."/"..maxSkillLevel)	
end

-- Tell user closest and best place to mine
function WTN:Location()
    cont = GetCurrentMapContinent()
    fontstring3 = frame:CreateFontString("name", "frame", "ActionBarButtonTemplate")
	fontstring3:SetFont("Fonts\\ARIALN.ttf", 12, "MONOCHROME") 	
	fontstring3:SetPoint("CENTER", 0, -13)
	
	-- Account for start zones
	if skillLevel < 50 then
		-- Alliance Start Zones
		if Race == "Human" then
			fontstring3:SetText("Copper Ore \n in \n Elwynn Forest")
		end
		if Race == "Dwarf" or Race == "Gnome" then
			fontstring3:SetText("Copper Ore \n in \n Dun Morogh")
		end
		if Race == "Worgen" or Race == "Night Elf" then
			fontstring3:SetText("Copper Ore \n in \n Darkshore")
		end
		if Race == "Draenei" then
			fontstring3:SetText("Copper Ore \n in \n Azuremyst Isle")
		end
		--Horde Start Zones
		if Race == "Orc"  or Race == "Troll" then
			fontstring3:SetText("Copper Ore \n in \n Durotar")
		end
		if Race == "Tauren" then
			fontstring3:SetText("Copper Ore \n in \n Mulgore")
		end
		if Race == "Undead" then
			fontstring3:SetText("Copper Ore \n in \n Tristfal Glades")
		end
		if Race == "Blood Elf" then
			fontstring3:SetText("Copper Ore \n in \n Eversong Woods")
		end
		if Race == "Goblin" then
			fontstring3:SetText("Copper Ore \n in \n Azshara")
		end
	end
	-- Beyond startZone
	if skillLevel > 50 and skillLevel < 100 then
		if cont == 2 then
			fontstring3:SetText("Tin in Hillsbrad")
		end
		elseif cont == 1 then
			fontstring3:SetText("Tin in Ashenvale")
	end
	if skillLevel > 100 and skillLevel < 150 then
		if cont == 2 then
			fontstring3:SetText("Iron Ore \n in \n Western Plaguelands")
		end
		elseif cont == 1 then
			fontstring3:SetText("Iron Ore \n in \n Feralas")
	end
	if skillLevel > 150 and skillLevel < 200 then
		if cont == 2 then
			fontstring3:SetText("Mithril Ore \n in \n Badlands")
		end
		elseif cont == 1 then
			fontstring3:SetText("Mithril Ore \n in \n Felwood")
	end
	if skillLevel > 200 and skillLevel < 275 then
		if cont == 2 then
			fontstring3:SetText("Thorium Ore \n in \n Blasted Lands")
		end
		elseif cont == 1 then
			fontstring3:SetText("Thorium Ore \n in \n Winterspring")
	end
	if skillLevel > 275 and skillLevel < 325 then
		fontstring3:SetText("Fel Iron Ore \n in \n Hellfire")
	end
	if skillLevel > 325 and skillLevel < 350 then
		fontstring3:SetText("Adamantium Iron Ore \n in \n Nagrand")
	end
	if skillLevel > 350 and skillLevel < 400 then
		fontstring3:SetText("Cobalt Ore \n in \n Howling Fjord")
	end
	if skillLevel > 400 and skillLevel < 425 then
		fontstring3:SetText("Saronite Ore \n in \n Sholzar Basin")
	end
	if skillLevel > 425 and skillLevel < 475 then
		fontstring3:SetText("Obsidium Ore \n in \n Mount Hyjal")
	end
	if skillLevel > 475 then		
		fontstring3:SetText("Elementium Ore \n in \n Twighlight Highlands")
	end			
end

-- check and Notify user to skill up
function WTN:SkillNowCheck()
	if skillLevel == 50 then
		PlaySoundFile("Sound\\Spells\\Tradeskills\\MiningHitD.wav", "Master")
	 	print("You may now train as an Journeyman miner")
	end
	if skillLevel == 125 then
	 	PlaySoundFile("Sound\\Spells\\Tradeskills\\MiningHitD.wav", "Master")
	 	print("You may now train as an Artisan miner")
	end
	if skillLevel == 200 then
		PlaySoundFile("Sound\\Spells\\Tradeskills\\MiningHitD.wav", "Master")
	 	print("You may now train as an Expert miner")
	end
	if skillLevel == 275 then
		PlaySoundFile("Sound\\Spells\\Tradeskills\\MiningHitD.wav", "Master")
	 	print("You may now train as an Master miner")
	end
	if skillLevel == 350 then
		PlaySoundFile("Sound\\Spells\\Tradeskills\\MiningHitD.wav", "Master")
	 	print("You may now train as an Grand Master miner")
	end
	if skillLevel == 425 then
		PlaySoundFile("Sound\\Spells\\Tradeskills\\MiningHitD.wav", "Master")
	 	print("You may now train as an Illustrious Grand Master miner")
	end
end